package BinaryCounter "An example with a 4-bit asynchronous counter based on JK-flip-flops."
  package Components "Components used in the BinaryCounter example"
    extends Modelica.Icons.Package;

    model Counter "4-bit asychronous counter"
      Modelica.Electrical.Digital.Examples.Utilities.JKFF jKFF1 "JK FlipFlop Component 1." annotation(Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Examples.Utilities.JKFF jKFF2 "JK FlipFlop Component 2." annotation(Placement(visible = true, transformation(origin = {-20, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Examples.Utilities.JKFF jKFF3 "JK FlipFlop Component 3." annotation(Placement(visible = true, transformation(origin = {20, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Examples.Utilities.JKFF jKFF4 "JK FlipFlop Component 4." annotation(Placement(visible = true, transformation(origin = {60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Interfaces.DigitalInput Enable "Input enable signal" annotation(Placement(visible = true, transformation(origin = {-100, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Interfaces.DigitalInput CLK "Input clock signal" annotation(Placement(visible = true, transformation(origin = {-100, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Interfaces.DigitalOutput Q0 "Output pin 0" annotation(Placement(visible = true, transformation(origin = {110, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Interfaces.DigitalOutput Q1 "Output pin 1" annotation(Placement(visible = true, transformation(origin = {110, -15}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -18.495}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Interfaces.DigitalOutput Q2 "Output pin 2" annotation(Placement(visible = true, transformation(origin = {110, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Digital.Interfaces.DigitalOutput Q3 "Output pin 3" annotation(Placement(visible = true, transformation(origin = {110, 45}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(jKFF1.k, jKFF1.j) annotation(Line(visible = true, origin = {-73.5, 0}, points = {{3.5, -7}, {-1.5, -7}, {-1.5, 7}, {3.5, 7}}, color = {138, 45, 163}));
      connect(jKFF2.k, jKFF2.j) annotation(Line(visible = true, origin = {-33.5, 0}, points = {{3.5, -7}, {-1.5, -7}, {-1.5, 7}, {3.5, 7}}, color = {138, 45, 163}));
      connect(jKFF3.k, jKFF3.j) annotation(Line(visible = true, origin = {6.5, 0}, points = {{3.5, -7}, {-1.5, -7}, {-1.5, 7}, {3.5, 7}}, color = {138, 45, 163}));
      connect(jKFF4.k, jKFF4.j) annotation(Line(visible = true, origin = {46.5, 0}, points = {{3.5, -7}, {-1.5, -7}, {-1.5, 7}, {3.5, 7}}, color = {138, 45, 163}));
      connect(jKFF1.j, Enable) annotation(Line(visible = true, origin = {-80, 23.5}, points = {{10, -16.5}, {5, -16.5}, {5, 16.5}, {-20, 16.5}}, color = {138, 45, 163}));
      connect(jKFF2.j, Enable) annotation(Line(visible = true, origin = {-50, 23.5}, points = {{20, -16.5}, {15, -16.5}, {15, 16.5}, {-50, 16.5}}, color = {138, 45, 163}));
      connect(jKFF3.j, Enable) annotation(Line(visible = true, origin = {-20, 23.5}, points = {{30, -16.5}, {25, -16.5}, {25, 16.5}, {-80, 16.5}}, color = {138, 45, 163}));
      connect(jKFF4.j, Enable) annotation(Line(visible = true, origin = {10, 23.5}, points = {{40, -16.5}, {35, -16.5}, {35, 16.5}, {-110, 16.5}}, color = {138, 45, 163}));
      connect(jKFF1.clk, CLK) annotation(Line(visible = true, origin = {-82.5, -20}, points = {{12.5, 20}, {2.5, 20}, {2.5, -20}, {-17.5, -20}}, color = {138, 45, 163}));
      connect(jKFF1.q, jKFF2.clk) annotation(Line(visible = true, origin = {-42.5, 3.5}, points = {{-7.5, 3.5}, {-2.5, 3.5}, {-2.5, -3.5}, {12.5, -3.5}}, color = {138, 45, 163}));
      connect(jKFF2.q, jKFF3.clk) annotation(Line(visible = true, origin = {-2.5, 3.5}, points = {{-7.5, 3.5}, {-2.5, 3.5}, {-2.5, -3.5}, {12.5, -3.5}}, color = {138, 45, 163}));
      connect(jKFF3.q, jKFF4.clk) annotation(Line(visible = true, origin = {37.5, 3.5}, points = {{-7.5, 3.5}, {-2.5, 3.5}, {-2.5, -3.5}, {12.5, -3.5}}, color = {138, 45, 163}));
      connect(jKFF1.q, Q0) annotation(Line(visible = true, origin = {-5, -16.5}, points = {{-45, 23.5}, {-40, 23.5}, {-40, -28.5}, {115, -28.5}}, color = {138, 45, 163}));
      connect(jKFF2.q, Q1) annotation(Line(visible = true, origin = {51.667, -12.667}, points = {{-61.667, 19.667}, {-56.667, 19.667}, {-56.667, -22.333}, {33.333, -22.333}, {33.333, -2.333}, {58.333, -2.333}}, color = {138, 45, 163}));
      connect(jKFF3.q, Q2) annotation(Line(visible = true, origin = {64.167, -2.667}, points = {{-34.167, 9.667}, {-29.167, 9.667}, {-29.167, -27.333}, {15.833, -27.333}, {15.833, 17.667}, {45.833, 17.667}}, color = {138, 45, 163}));
      connect(jKFF4.q, Q3) annotation(Line(visible = true, origin = {85, 28.5}, points = {{-15, -21.5}, {-10, -21.5}, {-10, 16.5}, {25, 16.5}}, color = {138, 45, 163}));
      annotation(Documentation(info = "<html>
<h4>4-Bit Binary Counter</h4>

<p>The counter in this example is a 4-bit asynchronous counter based on JK flip-flops. The flip-flops are connected with both their J and K terminals to the enable pin, putting them in \"toggle mode\".</p>

<p style=\"text-align: center;\"><img src=\"modelica://BinaryCounter.Components.Counter/./DocumentationFiles/counterSchematic.png\" alt=\"\" style=\"width:600px\"  /></p>

<p>The flip-flop to the left will change its output state for each falling edge of the clock signal, which means that the output can be toggled with a button or a CPU clock, for example. In this particular case, it is convenient to think of this as a sort of \"slowdown\" from each flip-flop to the next. Since the output toggles for each falling edge of the clock, the clock toggles twice for each toggle of the output. If you connect the first flip-flop's output as a clock signal to flip-flop number two, the same thing will happen there, so the frequency will go down by half for each flip-flop.</p>

<p style=\"text-align: center;\"><img src=\"modelica://BinaryCounter.Components.Counter/./DocumentationFiles/counterGraph.png\" style=\"width:300px\"  alt=\"\" /></p>

<p>You can also compare this to how the mileage indicator on an old car works. There, the digits go from 0 to 9, and the first digit to the right indicates hundreds of meters, the second one indicates kilometers, the third one tens of kilometers, etc. In this case, the second digit \"wants to know\" when the first digit turns around to zero again so that it can count up by one. The same thing goes for the third digit. When the second digit goes around to zero, this is indicated by raising the value of the third digit. Since working in binary only requires two states, when the first digit decreases by one (goes from 1 to 0), the second digit gets increased by one. In binary you increase the value just by toggling from 0 to 1 or 1 to 0, so no actual counting is needed.</p>

<h4>JK Flip-Flops</h4>

<p>Flip-flops or latches are used as basic components in digital circuitry and work as a kind of memory that stores the state of one bit. By using multiple flip-flops, it is possible to construct digital state machines. A binary counter is basically a state machine that just cycles through its states for each cycle of a clock signal. The JK flip-flop is considered to be the most universal flip-flop design and can be used as different kinds of flip-flops just by adjusting how the input to the J and K terminals is done. In this example, the flip-flops are used with a toggling function, which means that the output is changed for each completed clock cycle. This is accomplished by feeding ones into both the J and K pins of the flip-flops. By putting only zeros on all the J and K terminals, the output will never change, regardless of the input. This makes it suitable to connect all the J and K terminals as an enable signal for the circuit. Below, you can see the truth table for JK flip-flops. The row of interest to us is marked with gray.</p>

<p style=\"text-align: center;\"><img src=\"modelica://BinaryCounter.Components.Counter/./DocumentationFiles/JKtruthtable.png\" style=\"width:285px\" alt=\"\" /></p>
</html>"), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, fillColor = {255, 253, 170}, fillPattern = FillPattern.Solid, extent = {{-90, -100}, {90, 100}}), Text(visible = true, origin = {-20, -20}, extent = {{-60, 0}, {60, 40}}, textString = "Counter"), Text(visible = true, origin = {0, -10}, extent = {{-80, 60}, {-40, 80}}, textString = "ENABLE"), Text(visible = true, origin = {-4, -50}, extent = {{64, 60}, {86, 80}}, textString = "Q2"), Text(visible = true, origin = {-4, 10}, extent = {{64, -80}, {86, -60}}, textString = "Q0"), Text(visible = true, origin = {-31.415, -17.488}, extent = {{-48.585, -48.585}, {-24.292, -36.438}}, textString = "CLK"), Text(visible = true, origin = {-2, -18}, extent = {{62, -12}, {84, 8}}, textString = "Q1"), Text(visible = true, origin = {-4, -10}, extent = {{64, 60}, {86, 80}}, textString = "Q3")}), Diagram(coordinateSystem(extent = {{-100, -80}, {110, 80}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
    end Counter;

    model BinaryToIntegerConverter "Block that converts a binary array to an integer number"
      import L = Modelica.Electrical.Digital.Interfaces.Logic;
      parameter Integer n = 8 "Number of bits.";
      Integer bit[n](start = fill(0, n)) "Internal state for bits.";
      Modelica.Electrical.Digital.Interfaces.DigitalInput x[n] annotation(Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, 100}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.IntegerOutput y annotation(Placement(visible = true, transformation(origin = {40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {0, -98.091}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
    equation
      for i in 1:n loop
        if x[i] == Modelica.Electrical.Digital.Interfaces.Logic.'0' then
          bit[i] = 0;
        else
          bit[i] = 1;
        end if;
      end for;
      y = integer(sum(bit[i] * 2 ^ (n - i) for i in 1:n));
      annotation(Documentation(info = "<html><div>
<h3>Model Principles</h3>
</div>
<div>
<p>This block takes an array of size n consisting of 1-bit numbers and converts the array into an integer number. The parameter n, the total number of bits, can be specified so that the block can be used for conversions of arbitrary size. The maximum size of the integer that the block can take follows 2<sup>n</sup>-1 if the integer is unsigned or 2<sup>n-1</sup>-1 if the integer is signed.</p>
</div></html>"), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, fillColor = {194, 194, 194}, fillPattern = FillPattern.Solid, lineThickness = 2, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, origin = {-33.333, -33.333}, lineColor = {144, 0, 108}, fillColor = {144, 0, 108}, fillPattern = FillPattern.Solid, points = {{-66.667, 133.333}, {-66.667, -66.667}, {133.333, -66.667}})}), Diagram(coordinateSystem(extent = {{-40, -40}, {40, 40}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5}), graphics = {Text(visible = true, origin = {0.085, 25}, extent = {{-35.085, -26.956}, {35.085, 26.956}}, textString = "Textual Model")}));
    end BinaryToIntegerConverter;
    annotation(Documentation(info = "<html></html>"), Diagram(coordinateSystem(extent = {{-148.5, -105.0}, {148.5, 105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
  end Components;

  model FourBitCounter "Demonstration model with a counter, clocks and a binary to integer converter"
    extends Modelica.Icons.Example;
    Components.Counter fourBitCounter "4-bit asynchronous counter." annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-40, -40}, {40, 40}}, rotation = 0)));
    Modelica.Electrical.Digital.Sources.Step enable(after = Modelica.Electrical.Digital.Interfaces.Logic.'1', before = Modelica.Electrical.Digital.Interfaces.Logic.'0', stepTime = 1) "Enable signal to the counter." annotation(Placement(transformation(extent = {{-90, 8}, {-50, 48}}, rotation = 0, origin = {-20, 12}), visible = true));
    Modelica.Electrical.Digital.Sources.DigitalClock clock(period = 1, startTime = 0, width = 50) "Clock signal to the counter." annotation(Placement(transformation(extent = {{-90, -48}, {-50, -8}}, rotation = 0, origin = {-20, -12}), visible = true));
    Components.BinaryToIntegerConverter integerOutput(n = 4) "Converted integer output from boolean states." annotation(Placement(visible = true, transformation(origin = {80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = -270)));
  equation
    connect(enable.y, fourBitCounter.Enable) annotation(Line(visible = true, origin = {-57.5, 32}, points = {{-12.5, 8}, {-2.5, 8}, {-2.5, -8}, {17.5, -8}}, color = {138, 45, 163}));
    connect(clock.y, fourBitCounter.CLK) annotation(Line(visible = true, origin = {-60, -32}, points = {{-10, -8}, {0, -8}, {0, 8}, {20, 8}}, color = {138, 45, 163}));
    connect(fourBitCounter.Q3, integerOutput.x[1]) annotation(Line(visible = true, origin = {57.5, 12}, points = {{-17.5, 12}, {2.5, 12}, {2.5, -12}, {12.5, -12}}, color = {138, 45, 163}));
    connect(fourBitCounter.Q2, integerOutput.x[2]) annotation(Line(visible = true, origin = {57.5, 4}, points = {{-17.5, 4}, {2.5, 4}, {2.5, -4}, {12.5, -4}}, color = {138, 45, 163}));
    connect(fourBitCounter.Q1, integerOutput.x[3]) annotation(Line(visible = true, origin = {57.5, -3.699}, points = {{-17.5, -3.699}, {2.5, -3.699}, {2.5, 3.699}, {12.5, 3.699}}, color = {138, 45, 163}));
    connect(fourBitCounter.Q0, integerOutput.x[4]) annotation(Line(visible = true, origin = {57.5, -12}, points = {{-17.5, -12}, {2.5, -12}, {2.5, 12}, {12.5, 12}}, color = {138, 45, 163}));
    annotation(preferredView = "info", experiment(StopTime = 18.0, __Wolfram_SynchronizeWithRealTime = false), __Wolfram, Documentation(info = "<html>


    <p>
This model studies how a simple 4-bit binary counter may be set up. Counters can be used for a huge array of applications. They can, for example, be used to count pulses from a sensor attached to a wheel to count the number of revolutions, which in turn can be used to calculate the speed of the wheel. Counters also can be used as digital clocks for different purposes. Another typical use of a digital counter is in central processing units (CPUs), where a certain kind of counter (program counters, or PCs) is used as a way for the CPU to walk through program instructions, one by one, from a memory.
</p>
    <h4>Counter Model</h4>
    <p>
The counter in this example is a 4-bit asynchronous counter based on JK flip-flops. For more details about the counter and how it works, you can check out the documentation for the <a href=\"modelica://BinaryCounter.Components.Counter\">counter model</a> in the components package of this example.
</p><p style=\"text-align: center;\">
<img src=\"./DocumentationFiles/counterSchematic.png\" style=\"width:600px\" alt=\"\"/></p>

    <h4>Simulation</h4>
    <p>
By simulating the model, you can get the graphs for the output of the four output pins and how they relate to one another. You will quickly see that an output toggles when its &quot;lower neighbor&quot; goes from 1 to 0.
</p><p>
To simulate the model, Click the Simulate button: <img src=\"./DocumentationFiles/play.svg\" style=\"width:20px\" alt=\"\"/>. You will be presented with a graph showing the state of the four output pins with respect to time. If you want to plot other states, you can make a new plot by clicking the New Plot Window button: <img src=\"./DocumentationFiles/diagram_yt.svg\" style=\"width:20px\" alt=\"\"/>. You can then choose which variables you want to plot. If you want to plot the clock signal, you just expand the Clock object under the Plot tab and check the box labeled &quot;y&quot;. If you would like to plot the new variable together with the outputs instead of a new plot, you can just add another subplot by clicking the New Plot Window button: <img src=\"./DocumentationFiles/addplot.svg\" style=\"width:20px\" alt=\"\"/>
</p>
    <h4>Expanding the Model</h4>
    <p>
If you would like to play around with this model and expand it by adding more flip-flops to make it count even higher, you can examine how the model works and just drag more flip-flops into the model and connect them accordingly. You can find the JK flip-flop and other flip-flops in the Modelica Standard Library under <b>Electrical&#9656;Digital&#9656;Examples&#9656;Utilities</b>. You can also adjust the clock speed by clicking the Clock element in the ExampleModel diagram. Under the tab labeled <span>General</span>, choose how long a period should be and for how what percent of the period the signal should be 1. Why not be a little adventurous and use the <a href=https://www.wolfram.com/system-modeler/libraries/model-plug/>ModelPlug library</a> to connect a sensor via an Arduino and make the model count the number of pulses it generates?
</p></html>", figures = {Figure(title = "Output states", identifier = "37147", preferred = true, plots = {Plot(curves = {Curve(y = fourBitCounter.Q0, legend = "Q0")}, y = Axis(min = 3, max = 4, label = "fourBitCounter.Q0")), Plot(curves = {Curve(y = fourBitCounter.Q1, legend = "Q1")}, x = Axis(min = 0, max = 20, unit = "s"), y = Axis(min = 3, max = 4)), Plot(curves = {Curve(y = fourBitCounter.Q2, legend = "Q2")}, y = Axis(min = 3, max = 4)), Plot(curves = {Curve(y = fourBitCounter.Q3, legend = "Q3")}, x = Axis(min = 0, max = 20, unit = "s"), y = Axis(min = 3, max = 4))}), Figure(title = "Input states", identifier = "a03f5", plots = {Plot(curves = {Curve(y = clock.y, legend = "Clock Signal")}, y = Axis(label = "fourBitCounter.Q0")), Plot(curves = {Curve(y = enable.y, legend = "Enable Signal")})}), Figure(title = "Integer output", identifier = "58fb9", plots = {Plot(curves = {Curve(y = integerOutput.y, legend = "Integer Output")}, y = Axis(label = "Output"))})}), Diagram(coordinateSystem(extent = {{-120, -80}, {120, 80}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
  end FourBitCounter;
  annotation(__Wolfram(openClass = BinaryCounter.FourBitCounter), preferredView = "info", uses(Modelica(version = "4.0.0")), Documentation(info = "<html></html>"), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {111, 0, 0}, fillColor = {255, 0, 0}, fillPattern = FillPattern.HorizontalCylinder, lineThickness = 4, extent = {{-90, -90}, {90, 90}}, radius = 25), Text(visible = true, origin = {12, 20.833}, textColor = {255, 255, 255}, extent = {{-102, -70.833}, {78, 29.167}}, textString = "Ex", fontName = "Arial")}));
end BinaryCounter;
